/* GmbSprite -- a widget for Gnome Memory Blocks
 * (http://gnome-memblocks.sourceforge.net)
 *
 * Copyright (C) 2000 The Free Software Foundation
 *
 * Authors: Volodymyr Babin <vb@dwuj.ichf.edu.pl>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdarg.h>
#include "gmb-sprite-utils.h"

void
gdk_rectangles_union (GdkRectangle * dst, GdkRectangle * src1, ...)
{
  va_list var_args;
  GdkRectangle * cur;

  g_return_if_fail (dst != NULL);

  dst->x = dst->y = dst->width = dst->height = 0;
  cur = src1;

  va_start (var_args, src1);
  while (cur)
    {
      gint16 x, y;

      x = dst->x;
      y = dst->y;

      dst->x = MIN (dst->x, cur->x);
      dst->y = MIN (dst->y, cur->y);
      dst->width = MAX (cur->x + cur->width, x + dst->width) - dst->x;
      dst->height = MAX (cur->y + cur->height, y + dst->height) - dst->y;

      cur = va_arg (var_args, GdkRectangle *);
    }
  va_end (var_args);
}