/* test-pixbuf -- test program for gmb-sprite-pixbuf code
 * Copyright (C) 2000 Volodymyr Babin <vb@dwuj.ichf.edu.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 *  Very ugly, but this is test only.
 */

#include <math.h>
#include <gtk/gtk.h>
#include "gmb-sprite/gmb-sprite.h"

static GdkPixbuf * pixbuf_A;
static GdkPixbuf * pixbuf_B;
static GmbSprite * sprite;

enum
{
  SMOOTH,
  SHARP,
  STEP,
  DELAY,
  ALPHA,
  TO_A,
  TO_B,
  TO_NULL,
  ABORT,
  FORCE,
  REF_COUNT,
  LAST_CONTROL
};

static GtkWidget * c[LAST_CONTROL];

static gint
event_cb (GmbSprite * sp, GdkEvent * event, gpointer data)
{
  static gint16 start_x, start_y;

  if (event->type == GDK_BUTTON_PRESS)
    {
      start_x = (gint16) event->button.x;
      start_y = (gint16) event->button.y;
    }

  if (event->type == GDK_MOTION_NOTIFY && ((GdkEventMotion *) event)->state == GDK_BUTTON1_MASK)
    {
      gint16 dx, dy;
      dx = ((gint16) event->motion.x) - start_x;
      dy = ((gint16) event->motion.y) - start_y;
      if (sp->area.x + dx > 0 && sp->area.y + dy > 0)
        {
	  start_x = (gint16) event->motion.x;
          start_y = (gint16) event->motion.y;
	  gmb_sprite_move (sp, dx, dy);
	}
    }

  if (event->type == GDK_2BUTTON_PRESS)
    {
      GdkPixbuf * current;

      current = gmb_sprite_pixbuf_get_pixbuf (GMB_SPRITE_PIXBUF (sp));
      if (current)
        {
          guint step, delay;
	  GdkPixbuf * target = NULL;

          if (current == pixbuf_A)
	    {
	      target = pixbuf_B;
	      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (c[TO_B]), TRUE);
	    }
          if (current == pixbuf_B)
	    {
	      target = pixbuf_A;
	      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (c[TO_A]), TRUE);
	    }

          step = (guint) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[STEP]));
          delay = (guint) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[DELAY]));
          gmb_sprite_pixbuf_set_pixbuf_smooth (GMB_SPRITE_PIXBUF (sp), target, step, delay);
	}
    }

  return TRUE;
}

static void
smooth_cb (GtkWidget * w, gpointer data)
{
  guint step;
  guint delay;
  GdkPixbuf * target;

  target = NULL;

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (c[TO_A])))
    target = pixbuf_A;
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (c[TO_B])))
    target = pixbuf_B;

  step = (guint) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[STEP]));
  delay = (guint) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[DELAY]));
  gmb_sprite_pixbuf_set_pixbuf_smooth (GMB_SPRITE_PIXBUF (sprite), target, step, delay);
}

static void
sharp_cb (GtkWidget * w, gpointer data)
{
  guint step;
  guint delay;
  GdkPixbuf * target;

  target = NULL;

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (c[TO_A])))
    target = pixbuf_A;
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (c[TO_B])))
    target = pixbuf_B;

  step = (guint) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[STEP]));
  delay = (guint) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[DELAY]));
  gmb_sprite_pixbuf_set_pixbuf_now (GMB_SPRITE_PIXBUF (sprite), target);
}

static void
alpha_cb (GtkWidget * w, gpointer data)
{
  gmb_sprite_pixbuf_set_alpha (GMB_SPRITE_PIXBUF (sprite),
			       gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (c[ALPHA])));
}

static void
abort_cb (GtkWidget * w, gpointer data)
{
  gmb_sprite_pixbuf_abort_operation (GMB_SPRITE_PIXBUF (sprite));
}

static void
force_cb (GtkWidget * w, gpointer data)
{
  gmb_sprite_pixbuf_force_operation (GMB_SPRITE_PIXBUF (sprite));
}

static void
operation_finished_cb (GmbSpritePixbuf * pb, gpointer data)
{
  g_message ("Operation finished");
}

static void
ref_count_cb (GtkWidget *w, gpointer data)
{
  GdkPixbuf * cur;

  g_message ("Ref.Count of A = %d", * ((int *) pixbuf_A));
  g_message ("Ref.Count of B = %d", * ((int *) pixbuf_B));
  cur = gmb_sprite_pixbuf_get_pixbuf (GMB_SPRITE_PIXBUF (sprite));
  if (cur)
    g_message ("Ref.Count of the owned by sprite pixbuf = %d", * ((int *) cur));
  else
    g_message ("Sprite is empty");
}

int
main (int argc, char ** argv)
{
  GtkWidget * window;
  GtkWidget * gsa;
  GtkWidget * hbox, * vbox, * frame, * label;
  GtkAdjustment * adj;

  if (argc < 3)
    {
      g_message ("Usage: test-pixbuf <image1> <image2>");
      return 0;
    }

  gtk_init (&argc, &argv);
  gtk_widget_set_default_visual (gdk_rgb_get_visual ());
  gtk_widget_set_default_colormap (gdk_rgb_get_cmap ());

  pixbuf_A = gdk_pixbuf_new_from_file (argv[1]);
  if (pixbuf_A == NULL)
    {
      g_error ("failed to load image from %s", argv[1]);
      return 1;
    }

  pixbuf_B = gdk_pixbuf_new_from_file (argv[2]);
  if (pixbuf_B == NULL)
    {
      g_error ("failed to load image from %s", argv[2]);
      return 1;
    }

  window = gtk_widget_new (GTK_TYPE_WINDOW,
			   "GtkWindow::type", GTK_WINDOW_TOPLEVEL,
			   "GtkWindow::title", "Sprite Pixbuf Test",
			   "GtkContainer::border_width", 5, NULL);
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
  hbox = gtk_widget_new (GTK_TYPE_HBOX,
			 "GtkBox::spacing", 0,
			 "GtkBox::homogeneous", FALSE, NULL);
  gtk_container_add (GTK_CONTAINER (window), hbox);
  vbox = gtk_widget_new (GTK_TYPE_VBOX,
			 "GtkBox::spacing", 5,
			 "GtkBox::homogeneous", FALSE, NULL);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 5);
  frame = gtk_widget_new (GTK_TYPE_FRAME,
			  "GtkFrame::label", " Sprite Area ",
			  "GtkContainer::border_width", 0, NULL);
  gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 5);
  c[SMOOTH] = gtk_button_new_with_label ("Set Smooth");
  gtk_signal_connect (GTK_OBJECT (c[SMOOTH]), "clicked",
		      GTK_SIGNAL_FUNC (smooth_cb), NULL);
  gtk_box_pack_start (GTK_BOX (vbox), c[SMOOTH], FALSE, FALSE, 0);
  c[SHARP] = gtk_button_new_with_label ("Set Now");
  gtk_signal_connect (GTK_OBJECT (c[SHARP]), "clicked",
		      GTK_SIGNAL_FUNC (sharp_cb), NULL);
  gtk_box_pack_start (GTK_BOX (vbox), c[SHARP], FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), gtk_hseparator_new (), FALSE, FALSE, 10);

  c[ABORT] = gtk_button_new_with_label ("Abort");
  gtk_signal_connect (GTK_OBJECT (c[ABORT]), "clicked",
		      GTK_SIGNAL_FUNC (abort_cb), NULL);
  gtk_box_pack_start (GTK_BOX (vbox), c[ABORT], FALSE, FALSE, 0);

  c[FORCE] = gtk_button_new_with_label ("Force");
  gtk_signal_connect (GTK_OBJECT (c[FORCE]), "clicked",
		      GTK_SIGNAL_FUNC (force_cb), NULL);
  gtk_box_pack_start (GTK_BOX (vbox), c[FORCE], FALSE, FALSE, 0);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 15);
  label = gtk_label_new ("Alpha Step");
  gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 5);
  adj = (GtkAdjustment*) gtk_adjustment_new (16.0, 0.0, 255.0, 1.0, 16.0, 16.0);
  c[STEP] = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (c[STEP]), FALSE);
  gtk_spin_button_set_digits (GTK_SPIN_BUTTON (c[STEP]), 0);
  gtk_box_pack_start (GTK_BOX (hbox), c[STEP], FALSE, FALSE, 5);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 15);
  label = gtk_label_new ("Delay");
  gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 5);
  adj = (GtkAdjustment*) gtk_adjustment_new (20.0, 0.0, 1000.0, 1.0, 16.0, 16.0);
  c[DELAY] = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (c[DELAY]), FALSE);
  gtk_spin_button_set_digits (GTK_SPIN_BUTTON (c[DELAY]), 0);
  gtk_box_pack_start (GTK_BOX (hbox), c[DELAY], FALSE, FALSE, 5);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 15);
  label = gtk_label_new ("Alpha");
  gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 5);
  adj = (GtkAdjustment*) gtk_adjustment_new (127.0, 0.0, 255.0, 1.0, 16.0, 16.0);
  c[ALPHA] = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (c[ALPHA]), FALSE);
  gtk_spin_button_set_digits (GTK_SPIN_BUTTON (c[ALPHA]), 0);
  gtk_box_pack_start (GTK_BOX (hbox), c[ALPHA], FALSE, FALSE, 5);
  gtk_signal_connect (GTK_OBJECT (c[ALPHA]), "changed",
		      GTK_SIGNAL_FUNC (alpha_cb), NULL);

  gtk_box_pack_start (GTK_BOX (vbox), gtk_hseparator_new (), FALSE, FALSE, 10);
  c[TO_A] = gtk_radio_button_new_with_label (NULL, "Current -> A");
  gtk_box_pack_start (GTK_BOX (vbox), c[TO_A], FALSE, FALSE, 0);
  c[TO_B] = gtk_radio_button_new_with_label
    (gtk_radio_button_group (GTK_RADIO_BUTTON (c[TO_A])), "Current -> B");
  gtk_box_pack_start (GTK_BOX (vbox), c[TO_B], FALSE, FALSE, 0);
  c[TO_NULL] = gtk_radio_button_new_with_label
    (gtk_radio_button_group (GTK_RADIO_BUTTON (c[TO_B])), "Current -> NULL");
  gtk_box_pack_start (GTK_BOX (vbox), c[TO_NULL], FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (vbox), gtk_hseparator_new (), FALSE, FALSE, 10);
  c[REF_COUNT] = gtk_button_new_with_label ("Ref.Counts");
  gtk_signal_connect (GTK_OBJECT (c[REF_COUNT]), "clicked",
		      GTK_SIGNAL_FUNC (ref_count_cb), NULL);
  gtk_box_pack_start (GTK_BOX (vbox), c[REF_COUNT], FALSE, FALSE, 0);

  gsa = gmb_sprite_area_new ();
  gtk_widget_set_usize (gsa, 150, 150);
  gtk_container_add (GTK_CONTAINER (frame), gsa);

  sprite = gmb_sprite_pixbuf_new ();
  gtk_signal_connect (GTK_OBJECT (sprite), "operation_finished",
		      GTK_SIGNAL_FUNC (operation_finished_cb), NULL);

  gmb_sprite_pixbuf_set_alpha (GMB_SPRITE_PIXBUF (sprite), 127);
  gmb_sprite_pixbuf_set_pixbuf_now (GMB_SPRITE_PIXBUF (sprite), pixbuf_A);
  gmb_sprite_area_add_sprite_top (GMB_SPRITE_AREA (gsa), sprite, 20, 50);
  gtk_signal_connect (GTK_OBJECT (sprite), "event",
		      GTK_SIGNAL_FUNC (event_cb), NULL);

  gtk_rc_parse ("tests/test.gtkrc");
  gtk_rc_parse ("../tests/test.gtkrc");
  gtk_rc_parse ("test.gtkrc");

  gtk_widget_show_all (window);
  g_message ("\n\n****    You can drag sprite by mouse     ****\n**** Also try double-click on the sprite ****\n\n");
  gtk_main ();
  return 0;
}